#!/usr/bin/env python3

from AppKit import *
from comipoli_window import ComipoliWindow
from comipoli_menu import ComipoliMenu

class AppDelegate(NSObject):
    def applicationWillFinishLaunching_(self, notification):
        # preference
        defaults = NSUserDefaults.alloc().initWithSuiteName_('com.sasakima.comipoli')
        defaults.registerDefaults_({
            'x': '50',
            'y': '50',
            'width': '700',
            'height': '400',
            'is_pdf': 'YES',
            'thumbnail_height': '120',
            'path_rar': '',
            'path_7za': ''
        })
        NSApp.init_frame = NSMakeRect(
            defaults.floatForKey_('x'),
            defaults.floatForKey_('y'),
            defaults.floatForKey_('width'),
            defaults.floatForKey_('height'))
        NSApp.is_pdf = defaults.boolForKey_('is_pdf')
        NSApp.thumbnail_height = defaults.floatForKey_('thumbnail_height')
        NSApp.path_rar = defaults.stringForKey_('path_rar')
        NSApp.path_7za = defaults.stringForKey_('path_7za')
        # first window
        window = ComipoliWindow.newWindow()

    def applicationWillTerminate_(self, sender):
        defaults = NSUserDefaults.alloc().initWithSuiteName_('com.sasakima.comipoli')
        defaults.setBool_forKey_(NSApp.is_pdf, 'is_pdf')
        defaults.setFloat_forKey_(NSApp.thumbnail_height, 'thumbnail_height')
        defaults.setObject_forKey_(NSApp.path_rar, 'path_rar')
        defaults.setObject_forKey_(NSApp.path_7za, 'path_7za')
        defaults.synchronize()

    def application_openFiles_(self, sender, filenames):
        NSApp.keyWindow().set_path(filenames[0])
        return True

class ComipoliApplication(NSApplication):
    # global variable
    init_frame = None
    is_pdf = False
    thumbnail_height = 120
    path_rar = ''
    path_7za = ''

def main():
    ComipoliApplication.sharedApplication()
    NSApp.setMainMenu_(ComipoliMenu.new())
    NSApp.setDelegate_(AppDelegate.new())
    NSApp.activateIgnoringOtherApps_(True)
    # Hide Auto Tab Bar
    NSWindow.setAllowsAutomaticWindowTabbing_(False)
    # run
    NSApp.run()
