#!/usr/bin/env python3

import objc
from AppKit import *

class ComipoliToolbar(NSToolbar):
    def init(self):
        objc.super(ComipoliToolbar, self).init()
        # open
        self.open_button = NSButton.alloc().initWithFrame_(NSMakeRect(10, 10, 60, 36))
        self.open_button.setTitle_('Open')
        self.open_button.setBezelStyle_(NSRoundedBezelStyle)
        self.open_button.setAction_('onOpenButtonClicked:')
        # title
        self.title_label = NSTextField.alloc().initWithFrame_(NSMakeRect(10, 10, 300, 20))
        self.title_label.setDrawsBackground_(False)
        #title_label.bordered = False
        self.title_label.setEditable_(False)
        self.title_label.setSelectable_(False)
        self.title_label.setStringValue_('Comipoli')
        self.title_label.setAlignment_(NSTextAlignmentCenter)
        # L/R
        self.lr_button = NSButton.alloc().initWithFrame_(NSMakeRect(10, 10, 60, 36))
        self.lr_button.setTitle_('L<-R')
        self.lr_button.setBezelStyle_(NSRoundedBezelStyle)
        #self.lr_button.setButtonType_(NSPushOnPushOffButton)
        self.lr_button.setAction_('onLRButtonClicked:')
        # thumbnail
        self.thumb_button = NSButton.alloc().initWithFrame_(NSMakeRect(10, 10, 60, 36))
        self.thumb_button.setImage_(NSImage.imageNamed_(NSImageNameIconViewTemplate))
        self.thumb_button.setBezelStyle_(NSRoundedBezelStyle)
        self.thumb_button.setAction_('onThumbButtonClicked:')
        self.thumb_button.setEnabled_(False)
        # event
        self.setDelegate_(self)
        return self

    def toolbarAllowedItemIdentifiers_(self, toolbar):
        return []

    def toolbarSelectableItemIdentifiers_(self, toolbar):
        return []

    def toolbarDefaultItemIdentifiers_(self, toolbar):
            return ['OPEN', NSToolbarFlexibleSpaceItemIdentifier,
                'TITLE', NSToolbarFlexibleSpaceItemIdentifier, 'LR', 'THUMBNAIL']

    def toolbar_itemForItemIdentifier_willBeInsertedIntoToolbar_(self, toolbar, itemIdentifier, flag):
            item = NSToolbarItem.alloc().initWithItemIdentifier_(itemIdentifier)
            if itemIdentifier == 'OPEN':
                item.setView_(self.open_button)
            elif itemIdentifier == 'TITLE':
                item.setView_(self.title_label)
            elif itemIdentifier == 'LR':
                item.setView_(self.lr_button)
            elif itemIdentifier == 'THUMBNAIL':
                item.setView_(self.thumb_button)
            return item
