#!/usr/bin/env python3

import os

HEAD = '''#!/usr/bin/env python3

import objc, os, re, zipfile, subprocess
from AppKit import *
from Quartz.CoreGraphics import *

PICEXT = '\.(jpe?g|png|gif)$'
'''
FOOT = 'main()\n'

lines = [HEAD]
begin = False

for filename in [s for s in os.listdir() if s.startswith('comipoli_')]:
    with open(filename) as f:
        lines.append('# {}\n'.format(filename))
        for l in f.read().split('\n'):
            if begin:
                lines.append(l)
            elif l.startswith('class'):
                begin = True
                lines.append(l)
    begin = False

lines.append(FOOT)

with open('Comipoli.py', 'w') as f:
    f.write('\n'.join(lines))
