#!/usr/bin/env python3

# make_icns.py
# This Program is Retina Display Mac Only

import os
from AppKit import *
from Quartz.CoreGraphics import *

# Preference
PNGFILE = 'icon.png'
ICONSET = 'comipoli.iconset'

src_image = NSImage.alloc().initWithContentsOfFile_(PNGFILE)
os.mkdir(ICONSET)
os.chdir(ICONSET)

def create_png(img, name):
    bmp = NSBitmapImageRep.imageRepWithData_(img.TIFFRepresentation())
    data = bmp.representationUsingType_properties_(NSBitmapImageFileTypePNG, {})
    data.writeToFile_atomically_(name, True)


for n in [512, 256, 128, 32, 16]:
    # 72dpi
    img = NSBitmapImageRep.imageRepWithData_(src_image.TIFFRepresentation()).CGImage()
    ctx = CGBitmapContextCreate(None, n, n, 8, 4 * n, CGColorSpaceCreateDeviceRGB(), kCGImageAlphaPremultipliedLast)
    CGContextDrawImage(ctx, CGRectMake(0, 0, n, n), img)
    imgref = CGBitmapContextCreateImage(ctx)
    image72dpi = NSImage.alloc().initWithCGImage_size_(imgref, (n,n))
    create_png(image72dpi, 'icon_{0}x{0}.png'.format(n))
    # 144dpi
    image144dpi = NSImage.alloc().initWithSize_(NSMakeSize(n, n))
    image144dpi.lockFocus()
    NSGraphicsContext.saveGraphicsState()
    NSGraphicsContext.currentContext().setImageInterpolation_(NSImageInterpolationHigh)
    src_image.drawInRect_(NSMakeRect(0, 0, n, n))
    NSGraphicsContext.restoreGraphicsState()
    image144dpi.unlockFocus()
    create_png(image144dpi, 'icon_{0}x{0}@2x.png'.format(n))
